%% Doing Economics with the Computer
% *Lecture 3: SOLUTIONS* $\\$
% Harris Dellas $\\$
% Lucas Kyriacou

%% Introduction to Matlab: Functions
% The objective of this exercise is to show you how you can write
% functions. Important note: you have to code functions in a separate
% m-File.

%% Compulsory Readings
% Read chapter 6 in Attaway (2019). The book is provided on Ilias. 

%% Further Exercises
% Practice by going through the practice questions in chapter 6 in Attaway (2019). 
% Solutions to the practice questions are available on Ilias. 

%% Housekeeping
% When you write a script, you should include these commands at the start.

clear all % Deletes memory
close all % closes open windows (figures etc.)
clc       % clears command window

%% 1 General Form
% The general form of a function file is as follows: 
% Right-click in 'Current Folder', New File, Function

%% In Class Exercise 1
% Consider the geometric series $x(n)= q^{n-1}, n=1,2, \dots$.  
% Compute the sum $s(n)= 1+ q + q^2 + q^3+ \dots + q^{n-1}$ for q = 0.5 and n = 10 using a function.
% Create a function file, sgs.m, that contains the function below. To
% produce the result call the function by typing:  ssum= sgs(0.5, 10).
 
ssum= sgs(0.5, 10)

%% In Class Exercise 2
% Write a function that computes the hypotenuse and the sum of the sides of a right angled triangle. Let the two sides be 4 and 5 respectively
% Create a function file, hypo.m, that contains the below function. To
% produce the result call the function [h,s] = hypo(4,5).

[h,s] = hypo(4,5)

%% In Class Exercise 3
% Write a function that computes the hypotenuse and the sum of the sides of a right 
% angled triangle with sides 4 and 5 as in exercise 2 above but now have
% one function call another, i.e.: 
% Write a function that computes the hypotenuse and calls the function
% summy that computes the sum of the sides.
% Get the objects of interest by inputting at the command prompt:
% [h,s]=hyposum(4,5).

[h,s] = hyposum(4,5)

%% Time permitting, In Class Exercise 4
% The function hdss.m solves for the steady state values of capital and
% consumption in the standard economic growth model.
% Note that the function is written as f(x)=0. 
% In order to solve this problem define the parameter values: 
% alpha=0.35; beta=0.99; delta=0.025; A=1; $param=[alpha; beta; delta; A];$ 
% Give initial guess of k and c, k0, c0: $k0=10; c0=1; x0=[k0; c0];$
% Then call the non-linear solver fcsolve to solve the system of the two
% non-linear equations as: x = fcsolve('hdss',x0,[],param);.

alpha=0.35; 
beta=0.99; 
delta=0.025; 
A=1; 
param=[alpha; beta; delta; A];

k0=10; 
c0=1; 
x0=[k0; c0];

z = hdss(x0,param);
x = fcsolve('hdss',x0,[],param);









